################################################################################
# log modell RRlog mit Erklaerungvariablen ###########
################################################################################
df.temp$not_DQ <- 
  ifelse(df.temp$quest_version==3,0,1)# zeigt an ob DQ oder
df.temp$not_DQ


table(df.temp$not_DQ)

# RRT, Cross, tria ####
# formula_rrt_plus<-response ~ not_DQ + compliance_q + concentration + honest_answ + trustin_ano
formula_rrt_plus<-response ~ not_DQ + compliance_q
formula_rrt_plus<-response ~ not_DQ + concentration
formula_rrt_plus<-response ~ not_DQ + trustin_ano
formula_rrt_plus<-response ~ not_DQ + honest_answ
# Faelle filtern
df.w_auswertung <- 
  df.temp %>% filter(quest_version==2 | quest_version==3) # Filter RRT+DQ
fit_rrtuq <- RRlog(formula_rrt_plus,
                   data=df.w_auswertung,
                   model="UQTknown",
                   p=c(p_hausnr, .25), 
                   group=not_DQ,
                   LR.test=TRUE,
                   fit.n = 50)
summary(fit_rrtuq)


# log modell (geht nicht) Crosswise
# Faelle filtern
df.w_auswertung <- 
  df.temp %>% filter(quest_version==4 | quest_version==3) # Filter cross+DQ
fit_cross <- RRlog(formula_rrt_plus,
                   data=df.w_auswertung,
                   model="Crosswise",
                   p=.25, 
                   group=not_DQ,
                   LR.test=TRUE,
                   fit.n = 150)
summary(fit_cross)

# log modell (geht nicht) trian
# Faelle filtern
df.w_auswertung <- 
  df.temp %>% filter(quest_version==1 | quest_version==3) # Filter tria+DQ
fit_tria <- RRlog(formula_rrt_plus,
                  data=df.w_auswertung,
                  model="Triangular",
                  p=.25, 
                  group=not_DQ,
                  LR.test=TRUE,
                  fit.n = 50)
summary(fit_tria)
